#ifndef ApproximatorPoint_H
#define ApproximatorPoint_H

#ifdef _MSC_VER
# pragma warning(disable:4786)
# pragma warning(disable:4503) // warning: decorated name length exceeded
#endif

#include <cassert>
#include <Geometry.H>
#include <iostream>

class ApproximatorPoint {
public:
  RnPoint point;
  RnPoint values;
  double  distance;
  double  bandwidth;
  int     count;

  explicit ApproximatorPoint(const RnPoint &pt, const RnPoint &vals,
		    const double dist = 0.0,
		    const double band = 0.0)
    :point(pt), values(vals), distance(dist), bandwidth(band), count(0) {}
  ApproximatorPoint(const ApproximatorPoint &pt)
    :point(pt.point), values(pt.values), distance(pt.distance),
     bandwidth(pt.bandwidth), count(pt.count) {}

  ApproximatorPoint &operator=(const ApproximatorPoint &pt) {
    point = pt.point; values = pt.values;
    distance = pt.distance; bandwidth = pt.bandwidth;
    count = pt.count; return *this;}

  bool operator<(const ApproximatorPoint &point) const {
    return distance < point.distance;}

  friend std::ostream &operator<<(std::ostream &out,
				  const ApproximatorPoint &p) {
    out << p.point << ' ' << p.values << ' ' << p.distance << ' ' <<
      p.bandwidth; return out;}
  friend std::istream &operator>>(std::istream &in, ApproximatorPoint &p) {
    in >> p.point >> p.values >> p.distance >> p.bandwidth; return in;}
};

#endif
