#ifndef Experience_H
#define Experience_H

#ifdef _MSC_VER
# pragma warning(disable:4786)
# pragma warning(disable:4503) // warning: decorated name length exceeded
#endif

#include <cassert>
#include <Geometry.H>
#include <iostream>

struct Experience {
  Experience( const RnPoint& p_state, int p_action, double p_reward, const RnPoint& p_next_state, bool p_goalState )
    : state( p_state ), action( p_action ), reward( p_reward ), next_state( p_next_state ), goalState( p_goalState )
  {}
  RnPoint state;
  int action;
  double reward;
  RnPoint next_state;
  bool goalState;

  friend std::ostream &operator<<(std::ostream &out, const Experience &e) 
  {
    out << e.state << ' ' << e.action << ' ' << e.reward << ' ' << e.next_state << ' ' << e.goalState; 
    return out;
  }

  friend std::istream &operator>>(std::istream &in, Experience &e )
  {
    in >> e.state >> e.action >> e.reward >> e.next_state >> e.goalState; 
    return in;
  }
};


#endif

